/**
 * @file  fox.c

 * @author Ángel González Redondo
 * @author Daniel Alarcón Fernández
 * @author Carlos Ferrando Galiana
 * @author Vicente Ferrandez Lopez
 * @date   October, 2014
 * @brief  Main file of the game.
 *
 * This file contain the main loop of our game.
 * The game is made for the Retroconsolas Alicante 2013 event.
 *
 * It is released under a GPL 3.0 license.
 *	Copyright (C) 2014  JDVC
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Special thanks to  Raúl Simarro for the library, and team Cocos for the sound effect "EFECTO0" and  the methods "pintapuntos" and "c_exit".
 *
 *   ____  _____  _  _    ____  __  __  ____   ___  __      __    ____
 *  ( ___)(  _  )( \/ )  (  _ \(  )(  )(  _ \ / __)(  )    /__\  (  _ \
 *   )__)  )(_)(  )  (    ) _ < )(__)(  )   /( (_-. )(__  /(__)\  )   /
 *  (__)  (_____)(_/\_)  (____/(______)(_)\_) \___/(____)(__)(__)(_)\_)
 *
 */


#include "cpcrslib.h"
#include "cpcwyzlib.h"


#define KEY_S			12
#define KEY_O			13
#define KEY_E			14
#define numBalas        5

extern const unsigned char sp_1[];	//masked sprite data
extern const unsigned char sp_2[];
extern const unsigned char sp_3[];	
extern const unsigned char sp_4[];	//masked sprite data
extern const unsigned char sp_5[];	//masked sprite data
extern const unsigned char sp_6[];	//masked sprite data
extern const unsigned char sp_7[];	// ENEMY2
extern const unsigned char sp_8[];  // ENEMY3

extern const unsigned char tintas[];	//inks
extern unsigned char buffer[];	//inks
unsigned char cifra0 = 0;
unsigned char cifra1 = 0;
unsigned char cifra2 = 0;
unsigned char cifra3 = 0;

unsigned char cifra0IA = 0;
unsigned char cifra1IA = 0;
unsigned char cifra2IA = 0;
unsigned char cifra3IA = 0;

unsigned char cont=0;
unsigned char dificultad=0;
unsigned char puntostotales=0;
unsigned char rand = 0;
unsigned char rand2 = 5;
unsigned char rand3 = 60;


unsigned char vidaBala = 0;
unsigned char mx = 0;
unsigned char my = 0;
unsigned char direccion=4;
unsigned char direccion2=4;
unsigned char ronda=0;
unsigned char memo = 0;

//powerdow
unsigned char contador=0;
unsigned char bloqueo=0;
unsigned char bloqueoJugador=0;
unsigned char tbloqueoJ=0;
unsigned char golpeaDown=0;
unsigned char powerdownEnMapa=0;
unsigned char tPowerDownSpawn = 0;

//powerup
unsigned char powerUpEnMapa = 0;
unsigned char tPowerUp = 0;
unsigned char powerUpOn = 0;
unsigned char velPowerUp = 0;
unsigned char tPowerUpSpawn = 0;
unsigned char tRespawn = 0;
unsigned char time = 0;



struct sprite  		// minimun sprite structure
{
    char *sp0;		//2 bytes 	01
    char *sp1;		//2 bytes	23
    int coord0;		//2 bytes	45	current superbuffer address
    int coord1;		//2 bytes	67  old superbuffer address
    unsigned char cx, cy;	//2 bytes 89 	current coordinates
    unsigned char ox, oy;	//2 bytes 1011  old coordinates
    unsigned char move1;	// los bits 4,3,2 definen el tipo de dibujo!!
    unsigned char move;		// 	in this example, to know the movement direction of the sprite


};
struct sprite sprite00,sprite01,sprite02,sprite03,sprite04,powerdown,powerup,enemy2,enemy3;


extern const unsigned char PlayerPalette[]={
		 0/*NEGRO*/, 26/*BLANCO*/, 6 /*ROJO*/ , 18 /*verde*/ , 25/*Superior*/, 15/*Central*/, 24/*inferior*/, 12/*Am.OSCURO*/, 2, 16, 22, 1, 20, 3, 14, 13
};

extern const int EFFECT_TABLE[];
extern const int SONG_TABLE_1[];
extern const int RULE_TABLE_1[];
extern const int SOUND_TABLE_1[];

const unsigned char SONG_1[] = {
	0x08,0x07,0x00,0x00,0x3F,0x00,0x23,0x21,0x23,0x23,0x25,0x23,0x21,0x23,0x23,0x1F,
	0x10,0x12,0x12,0x12,0x10,0x1A,0x0F,0x1A,0x0F,0x1A,0x0F,0x12,0x10,0x10,0x14,0x16,
0x25,0x18,0x25,0x23,0x25,0x21,0x00,0xC1,0x00,0xC1,0x00,0xC1,0x00,0x00
	};
	

//musica
void asm_data_audio(void) {

	// Music Player requiered data
	__asm

		_SONG_TABLE_1:
			.dw _SONG_1

		_RULE_TABLE_1: 
			.dw PAUTA_0
			
		_SOUND_TABLE_1: 
			.dw SONIDO_0
			
		PAUTA_0:	
				.DB	8,0,7,0,6,0,5,0,129
		SONIDO_0: 	
			.db 1711,1614,1524,1438,1358,1281,1210,1142,1078,1017,960,906,855,807,762,719,679,641,605,571,539,509,480,453,428,404,381,360,339,320,302,285,269,254,240,227,214,202,190,180,170,160,151,143,135,127,120,113,107,101,95,90,85,80,76,71,67,64,60,57

		// SFX
		_EFFECT_TABLE:
			.dw _EFECTO0
		_EFECTO0:
			.db #0x58,#0x0D
			.db #0x34,#0x0B
			.db #0x47,#0x0A
			.db #0x3E,#0x06
			.db #0x35,#0x03
			.db #0x50,#0x09
			.db #0xFF,#0x0A
			.db #0x3E,#0x07
			.db #0xFF
	__endasm;
}


//Aqui va el codigo de los sprites
void data(void)
{

    __asm
_buffer:
    .db #30
_sp_1:
	.db #03,#14
.db #0xFF,#0x00,#0x00,#0xCC,#0xFF,#0x00
.db #0xAA,#0x14,#0x00,#0x3C,#0x55,#0x28
.db #0xAA,#0x00,#0x00,#0x28,#0x00,#0x3C
.db #0xAA,#0x14,#0x00,#0x3C,#0x00,#0x3C
.db #0xAA,#0x00,#0x00,#0x3C,#0x55,#0x28
.db #0xFF,#0x00,#0xAA,#0x14,#0xFF,#0x00
.db #0x00,#0x68,#0x00,#0x94,#0x00,#0x94
.db #0x55,#0x28,#0x00,#0xC0,#0x00,#0x94
.db #0x55,#0x00,#0x00,#0xC0,#0xAA,#0x00
.db #0x55,#0x28,#0x00,#0x03,#0xAA,#0x14
.db #0xAA,#0x01,#0x00,#0x03,#0x55,#0x02
.db #0xAA,#0x01,#0xFF,#0x00,#0x55,#0x02
.db #0xAA,#0x54,#0xFF,#0x00,#0x55,#0xA8
.db #0x00,#0xFC,#0xFF,#0x00,#0x00,#0xFC

_sp_3:
	.DB 03, 14
.db #0xFF,#0x00,#0x00,#0x87,#0xFF,#0x00
.db #0xAA,#0x41,#0x00,#0x08,#0x55,#0x0A
.db #0xAA,#0x05,#0x00,#0x0F,#0x55,#0x0A
.db #0xAA,#0x00,#0x00,#0x00,#0xFF,#0x00
.db #0xAA,#0x05,#0x00,#0x0F,#0xFF,#0x00
.db #0xFF,#0x00,#0x55,#0x0A,#0xFF,#0x00
.db #0xAA,#0x05,#0x00,#0x0F,#0x55,#0x0A
.db #0x00,#0x0F,#0x00,#0x0F,#0x00,#0x0F
.db #0x55,#0x0A,#0x00,#0x0E,#0xAA,#0x05
.db #0x55,#0x0A,#0x00,#0x4B,#0xFF,#0x00
.db #0xFF,#0x00,#0x00,#0x0F,#0xFF,#0x00
.db #0xAA,#0x05,#0x00,#0x0F,#0x55,#0x0A
.db #0xAA,#0x05,#0xFF,#0x00,#0x55,#0x82
.db #0x00,#0x4B,#0xFF,#0x00,#0x55,#0x08

_sp_2:
	.DB 03, 6
.db #0xAA,#0x10,#0x00,#0x30,#0x55,#0xA8
.db #0x00,#0x30,#0x00,#0x3C,#0x00,#0xFC
.db #0x00,#0x34,#0x00,#0x7C,#0x00,#0x7C
.db #0x00,#0x34,#0x00,#0x7C,#0x00,#0x7C
.db #0x00,#0x30,#0x00,#0x3C,#0x00,#0xFC
.db #0xAA,#0x10,#0x00,#0xFC,#0x55,#0xA8

_sp_4:
	   .DB 4, 8
.db #0xAA,#0x00,#0x00,#0x55,#0x00,#0xF3,#0x55,#0xA2
.db #0x00,#0x00,#0x00,#0xFF,#0x00,#0x0C,#0x00,#0xF3
.db #0x00,#0x55,#0x00,#0xFF,#0x00,#0xAE,#0x00,#0x59
.db #0x00,#0xFF,#0x00,#0xFF,#0x00,#0xFF,#0x00,#0xFB
.db #0x00,#0x0C,#0x00,#0xF7,#0x00,#0xFF,#0x00,#0xFF
.db #0x00,#0xF3,#0x00,#0xF7,#0x00,#0xFF,#0x00,#0xAA
.db #0x00,#0xF7,#0x00,#0xFF,#0x00,#0xFF,#0x00,#0x00
.db #0xAA,#0x55,#0x00,#0x00,#0x00,#0x00,#0x55,#0x00

_sp_5:
.DB 2, 6
.db #0xAA,#0x04,#0x55,#0x82
.db #0xAA,#0x00,#0x55,#0x00
.db #0x00,#0x0C,#0x00,#0xC3
.db #0x00,#0x0C,#0x00,#0x49
.db #0x00,#0x0C,#0x00,#0x49
.db #0x00,#0x0C,#0x00,#0x49

_sp_6:
	.DB 02, 6
.db #0xAA,#0x44,#0x55,#0x0A
.db #0xAA,#0x00,#0x55,#0x00
.db #0x00,#0xCC,#0x00,#0x0F
.db #0x00,#0xCC,#0x00,#0x8D
.db #0x00,#0xCC,#0x00,#0x8D
.db #0x00,#0xCC,#0x00,#0x8D

_sp_7:
	.DB 03, 14
.db #0xAA,#0x40,#0x00,#0xA6,#0x55,#0x08
.db #0x00,#0xC0,#0x00,#0xD1,#0x55,#0xA2
.db #0x00,#0xC0,#0x00,#0x40,#0x55,#0x00
.db #0x00,#0xF3,#0x00,#0xC0,#0x55,#0x80
.db #0x00,#0x59,#0x00,#0x00,#0x55,#0x00
.db #0xAA,#0x40,#0x00,#0xC0,#0x55,#0x80
.db #0xFF,#0x00,#0x55,#0x80,#0xFF,#0x00
.db #0x00,#0xC0,#0x00,#0xC0,#0x00,#0xC0
.db #0x55,#0x80,#0x00,#0xC0,#0xFF,#0x00
.db #0x55,#0x80,#0x00,#0xC0,#0xFF,#0x00
.db #0xFF,#0x00,#0x00,#0xC0,#0xFF,#0x00
.db #0xFF,#0x00,#0x55,#0x80,#0x55,#0x80
.db #0xFF,#0x00,#0x55,#0x80,#0x55,#0x80
.db #0xFF,#0x00,#0x55,#0x80,#0x55,#0x80

_sp_8:
	.DB 03, 14
.db #0xAA,#0x04,#0x00,#0x59,#0x55,#0x80
.db #0xAA,#0x51,#0x00,#0xE2,#0x00,#0xC0
.db #0xAA,#0x00,#0x00,#0x80,#0x00,#0xC0
.db #0xAA,#0x40,#0x00,#0xC0,#0x00,#0xF3
.db #0xAA,#0x00,#0x00,#0x00,#0x00,#0xA6
.db #0xAA,#0x40,#0x00,#0xC0,#0x55,#0x80
.db #0xFF,#0x00,#0xAA,#0x40,#0xFF,#0x00
.db #0x00,#0xC0,#0x00,#0xC0,#0x00,#0xC0
.db #0xFF,#0x00,#0x00,#0xC0,#0xAA,#0x40
.db #0xFF,#0x00,#0x00,#0xC0,#0xAA,#0x40
.db #0xFF,#0x00,#0x00,#0xC0,#0xFF,#0x00
.db #0xAA,#0x40,#0xAA,#0x40,#0xFF,#0x00
.db #0xAA,#0x40,#0xAA,#0x40,#0xFF,#0x00
.db #0xAA,#0x40,#0xAA,#0x40,#0xFF,#0x00
// There is a tool called Sprot that allows to generate masked sprites for z88dk.
// ask for it: www.amstrad.es/forum/
    __endasm;
}

extern const unsigned char noCoin[]={
		6,12
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
		, 0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00
};


extern const unsigned char Cero[]={
 0x40,0x80,
 0x80,0x40,
 0x80,0x40,
 0x80,0x40,
 0x80,0x40,
 0x80,0x40,
 0x80,0x40,
 0x40,0x80

};

extern const unsigned char Uno[]={
 0x40,0x80
 ,0x00,0x80
 ,0x00,0x80
 ,0x00,0x80
 ,0x00,0x80
 ,0x00,0x80
 ,0x00,0x80
 ,0x40,0xC0
};

extern const unsigned char Dos[]={
     0xC0,0xC0
 ,0x00,0x40
 ,0x00,0x40
 ,0x00,0x40
 ,0xC0,0xC0
 ,0x80,0x00
 ,0x80,0x00
 ,0xC0,0xC0

};

extern const unsigned char Tres[]={
      0x40,0xC0
 ,0x00,0x40
 ,0x00,0x40
 ,0x40,0xC0
 ,0x40,0xC0
 ,0x00,0x40
 ,0x00,0x40
 ,0x40,0xC0
};

extern const unsigned char Cuatro[]={
       0x80,0x40
 ,0x80,0x40
 ,0x80,0x40
 ,0xC0,0xC0
 ,0x00,0x40
 ,0x00,0x40
 ,0x00,0x40
 ,0x00,0x40
};

extern const unsigned char Cinco[]={
     0xC0,0xC0
 ,0x80,0x00
 ,0x80,0x00
 ,0xC0,0xC0
 ,0x00,0x40
 ,0x00,0x40
 ,0x00,0x40
 ,0xC0,0xC0
};

extern const unsigned char Seis[]={
        0xC0,0xC0
 ,0x80,0x00
 ,0x80,0x00
 ,0xC0,0xC0
 ,0x80,0x40
 ,0x80,0x40
 ,0x80,0x40
 ,0xC0,0xC0
};

extern const unsigned char Siete[]={
      0xC0,0xC0
 ,0x00,0x40
 ,0x00,0x40
 ,0x40,0xC0
 ,0x00,0x40
 ,0x00,0x40
 ,0x00,0x40
 ,0x00,0x40

};

extern const unsigned char Ocho[]={
        0x40,0x80
 ,0x80,0x40
 ,0x80,0x40
 ,0xC0,0xC0
 ,0xC0,0xC0
 ,0x80,0x40
 ,0x80,0x40
 ,0x40,0x80

};

extern const unsigned char Nueve[]={
      0xC0,0xC0
 ,0x80,0x40
 ,0x80,0x40
 ,0xC0,0xC0
 ,0x00,0x40
 ,0x00,0x40
 ,0x00,0x40
 ,0x00,0x40
};

void actuaPuntos()
{
puntostotales++;
dificultad++;
	if(cifra0 ==10){
		cifra1++;
		cifra0 = 0;
		}
		
		if(cifra1 ==10){
		cifra2++;
		cifra1 = 0;
		}
		
		if(cifra2 ==10){
		cifra2 = 0;
		}
}

//grupo fox
void pintapuntos(){
			
		switch(cifra0){
		case 0: cpc_PutSp(Cero,8,2,0xcef4);break;
		case 1: cpc_PutSp(Uno,8,2,0xcef4);break;
		case 2: cpc_PutSp(Dos,8,2,0xcef4);break;
		case 3: cpc_PutSp(Tres,8,2,0xcef4);break;
		case 4: cpc_PutSp(Cuatro,8,2,0xcef4);break;
		case 5: cpc_PutSp(Cinco,8,2,0xcef4);break;
		case 6: cpc_PutSp(Seis,8,2,0xcef4);break;
		case 7: cpc_PutSp(Siete,8,2,0xcef4);break;
		case 8: cpc_PutSp(Ocho,8,2,0xcef4);break;
		case 9: cpc_PutSp(Nueve,8,2,0xcef4);break;
	}
	switch(cifra1){
		case 0: cpc_PutSp(Cero,8,2,0xcef2);break;
		case 1: cpc_PutSp(Uno,8,2,0xcef2);break;
		case 2: cpc_PutSp(Dos,8,2,0xcef2);break;
		case 3: cpc_PutSp(Tres,8,2,0xcef2);break;
		case 4: cpc_PutSp(Cuatro,8,2,0xcef2);break;
		case 5: cpc_PutSp(Cinco,8,2,0xcef2);break;
		case 6: cpc_PutSp(Seis,8,2,0xcef2);break;
		case 7: cpc_PutSp(Siete,8,2,0xcef2);break;
		case 8: cpc_PutSp(Ocho,8,2,0xcef2);break;
		case 9: cpc_PutSp(Nueve,8,2,0xcef2);break;
	}
	switch(cifra2){
		case 0: cpc_PutSp(Cero,8,2,0xcef0);break;
		case 1: cpc_PutSp(Uno,8,2,0xcef0);break;
		case 2: cpc_PutSp(Dos,8,2,0xcef0);break;
		case 3: cpc_PutSp(Tres,8,2,0xcef0);break;
		case 4: cpc_PutSp(Cuatro,8,2,0xcef0);break;
		case 5: cpc_PutSp(Cinco,8,2,0xcef0);break;
		case 6: cpc_PutSp(Seis,8,2,0xcef0);break;
		case 7: cpc_PutSp(Siete,8,2,0xcef0);break;
		case 8: cpc_PutSp(Ocho,8,2,0xcef0);break;
		case 9: cpc_PutSp(Nueve,8,2,0xcef0);break;
	}
	switch(cifra3){
		case 0: cpc_PutSp(Cero,8,2,0xceee);break;
		case 1: cpc_PutSp(Uno,8,2,0xceee);break;
		case 2: cpc_PutSp(Dos,8,2,0xceee);break;
		case 3: cpc_PutSp(Tres,8,2,0xceee);break;
		case 4: cpc_PutSp(Cuatro,8,2,0xceee);break;
		case 5: cpc_PutSp(Cinco,8,2,0xceee);break;
		case 6: cpc_PutSp(Seis,8,2,0xceee);break;
		case 7: cpc_PutSp(Siete,8,2,0xceee);break;
		case 8: cpc_PutSp(Ocho,8,2,0xceee);break;
		case 9: cpc_PutSp(Nueve,8,2,0xceee);break;
	}
}

void *p_sprites[10];


void initPointers()
{

    p_sprites[0] = &sprite00;
    p_sprites[1] = &sprite01;
    p_sprites[2] = &sprite02;
	p_sprites[3] = &sprite03;
	p_sprites[4] = &powerdown;
	p_sprites[5] = &powerup;
	p_sprites[6] = &enemy2;
	p_sprites[7] = &enemy3;

}

void set_colours(void)
{
    unsigned char x;
	for (x=0; x<16; x++)
    {
        cpc_SetInk(x,PlayerPalette[x]);
    }
    cpc_SetBorder(0);
}

//grupo fox
void c_exit(void){
	__asm
		call #0x0000
	__endasm;
}

unsigned char collide()
{
    cpc_ClrScr();
	cpc_PrintGphStrXY("GAME OVER",30,80);
	cpc_PrintGphStrXY("PULSA O PARA REINICIAR",0,110);
	cpc_PrintGphStrXY("PULSA S PARA SALIR ",0,120);
	cpc_WyzSetPlayerOff();	
	drawpuntos();
	pintapuntos();
	 while(1){
	    if(cpc_TestKey(KEY_O)==1){
			
	    	return 0;
	    }
	    else if(cpc_TestKey(KEY_S)==1){
	    	return 1;
	    }
	 }
}

void draw_tilemap(void)
{

 unsigned char x,y;

    for(x=0; x < 32; x++)
    	for(y=0; y < 16; y++)
    		cpc_SetTile(x,y,2);
			
}

void drawpuntos(void)
{	
	cpc_PutSp(Cero,8,2,0xceee);
	cpc_PutSp(Cero,8,2,0xcef0);
	cpc_PutSp(Cero,8,2,0xcef2);
	cpc_PutSp(Cero,8,2,0xcef4);
	cpc_PrintGphStrXY("PUNTOS",12,165); 
	
}

void initGame(void)
{
	cifra0 = 0;
	cifra1 = 0;
	cifra2 = 0;
	cifra3 = 0;
	cont=0;
   dificultad=0;
   puntostotales=0;
     contador=0;
  bloqueo=0;
  bloqueoJugador=0;
  tbloqueoJ=0;
  golpeaDown=0;
    powerUpEnMapa = 0;
  tPowerUp = 0;
  powerUpOn = 0;
  velPowerUp = 0;
  tPowerUpSpawn = 0;
  powerdownEnMapa = 0;
	initPointers();
	cpc_ClrScr();
	drawpuntos();
	rand3 = 60;
	tRespawn = 65;
	
    // Aqui se declara cada estructura sprite, su x actual,su y actual, su grafico, su x anterior y su y anterior
    //player
	sprite00.sp1=sp_1;
    sprite00.sp0=sp_1;
    sprite00.ox=20;
    sprite00.oy=10;
    sprite00.cx=20;
    sprite00.cy=10;
    sprite00.move1=3;
    cpc_SuperbufferAddress(p_sprites[0]); //first time it's important to do this
	
	//coin
    sprite01.sp1=sp_2;
    sprite01.sp0=sp_2;
    sprite01.ox=50;
    sprite01.oy=106;
    sprite01.cx=50;
    sprite01.cy=106;
    sprite01.move=1;
    sprite01.move1=3;
    cpc_SuperbufferAddress(p_sprites[1]);

	//IA
    sprite02.sp1=sp_3;
    sprite02.sp0=sp_3;
    sprite02.ox=50;
    sprite02.oy=90;
    sprite02.cx=50;
    sprite02.cy=90;
    sprite02.move=1;
    sprite02.move1=3;
    cpc_SuperbufferAddress(p_sprites[2]);
	
	//DANIEL - sprite de la bala, sobre todo que empiece transparente, y le meto la cx cy del prota #YOLO
	//BALA
	sprite03.sp1=noCoin;
    sprite03.sp0=noCoin;
    sprite03.ox=50;
    sprite03.oy=50;
    sprite03.cx=sprite00.cx;
    sprite03.cy=sprite00.cy+5;
    sprite03.move=1;
    sprite03.move1=3;
    cpc_SuperbufferAddress(p_sprites[3]);
	//FIN DANIEL
		
	powerdown.sp1=noCoin;
    powerdown.sp0=noCoin;
    powerdown.ox=50;
    powerdown.oy=90;
    powerdown.cx=40;
    powerdown.cy=40;
    powerdown.move=1;
    powerdown.move1=3;
    cpc_SuperbufferAddress(p_sprites[4]);
	
	powerup.sp1=noCoin;
    powerup.sp0=noCoin;
    powerup.ox=60;
    powerup.oy=60;
    powerup.cx=sprite00.cx;
    powerup.cy=sprite00.cy+5;
    powerup.move=1;
    powerup.move1=3;
    cpc_SuperbufferAddress(p_sprites[5]);
	
	enemy2.sp1=sp_7;
    enemy2.sp0=sp_7;
    enemy2.ox=10;
    enemy2.oy=10;
    enemy2.cx=10;
    enemy2.cy=10;
    enemy2.move=1;
    enemy2.move1=3;
    cpc_SuperbufferAddress(p_sprites[6]);
	
	enemy3.sp1=sp_8;
    enemy3.sp0=sp_8;
    enemy3.ox=50;
    enemy3.oy=90;
    enemy3.cx=50;
    enemy3.cy=90;
    enemy3.move=1;
    enemy3.move1=3;
    cpc_SuperbufferAddress(p_sprites[7]);
	
	
	cpc_WyzInitPlayer(SOUND_TABLE_1, RULE_TABLE_1, EFFECT_TABLE, SONG_TABLE_1);		//initialize data
	cpc_WyzLoadSong(0);	//Select song to play (uncompress it and the start to play)
	cpc_WyzSetPlayerOn();		//start music and sound effects (SFX)
	cpc_WyzSetTempo(4);

    //Drawing the tile map
    draw_tilemap();
    cpc_SetTile(0,1,2);


    cpc_ShowTileMap();		//Show entire tile map in the screen
}

void menu(){
	unsigned int emp = 0;
	//cpc_SetInkGphStr(2,10);
	cpc_ClrScr();
	cpc_PrintGphStrXY("THE THIEF RUNNER",30,80);
	cpc_PrintGphStrXY("PULSA E PARA EMPEZAR",0,110);
	cpc_PrintGphStrXY("PULSA S PARA SALIR ",0,120);
	
	while(emp==0)
	{
		if(cpc_TestKey(KEY_E)==1){
	    	emp=1;
	    }
	    else if(cpc_TestKey(KEY_S)==1){
	    	c_exit();
	    }
	}	
}

main()
{
	unsigned char a;
	
	
	cpc_AssignKey (KEY_S, 0x4710);		// s
	cpc_AssignKey (KEY_O, 0x4404);		// o
	cpc_AssignKey (KEY_E, 0x4704);		// e
	cpc_AssignKey(4, 0x4780);			//X
	 
	set_colours();
    cpc_SetInkGphStr(0,0);
    cpc_SetModo(0);
  
  cpc_DisableFirmware();
	
	
    menu();
    initGame();
	
    while(1)
    {
		
        //Default number keys for moving one of the sprites:
        // 0: cursor right
        // 1: cursor left
        // 2: cursor up
        // 3: cursor down

        //for example., if key 0 is pressed, and the sprite is inside tilemap, then
        //the sprite is moved one byte to the right:
		//DANIEL - AÑADE LA ASIGNACION DE "direccion" a segun que flecha de direccion le des,
		if(bloqueoJugador==0){
			if (cpc_TestKey(0)==1 && sprite00.cx<55){ sprite00.cx+=(2+velPowerUp); direccion=0;}
			if (cpc_TestKey(1)==1 && sprite00.cx>5){ sprite00.cx-=(2+velPowerUp); direccion=1;}
			if (cpc_TestKey(2)==1 && sprite00.cy>0) {sprite00.cy-=(2); direccion=2;}
			if (cpc_TestKey(3)==1 && sprite00.cy<107) {sprite00.cy+=(2); direccion=3;}
		}
		
		//DANIEL
		//DISPARO
		if(cpc_TestKey(4)==1 && vidaBala==0){ //disparo(numBalas, time);
			//movimiento inicial segun direccion
				//if(time<30){
				//memo=1;
				//default, tiro en +y
				if (direccion==0){ mx=sprite00.cx+5; my=sprite00.cy; direccion2=0;}//aderecha
				else if (direccion==1) {mx=sprite00.cx-5; my=sprite00.cy; direccion2=1;}//aizquierda
				else if (direccion==2){ mx=sprite00.cx; my=sprite00.cy-5; direccion2=2;}//arriba
				else if (direccion==3) {mx=sprite00.cx; my=sprite00.cy+5; direccion2=3;}//abajo	
				else {mx=sprite00.cx; my=sprite00.cy+5; direccion2=3;}
				sprite03.sp1=sp_4;
				sprite03.sp0=sp_4;
				ronda=1;
				//}		
				vidaBala=1;
		}
		else if(vidaBala==1){//movemos la bala ya disparada
			
				if (direccion2==0){mx=sprite03.cx+5; my=sprite03.cy; }//aderecha
				if (direccion2==1){mx=sprite03.cx-5; my=sprite03.cy; }//aizquierda
				if (direccion2==2){mx=sprite03.cx; my=sprite03.cy-5; }//arriba
				if (direccion2==3){mx=sprite03.cx; my=sprite03.cy+5; }//abajo
				ronda=2;
		}
		else{vidaBala =0; ronda=0;}//machacando valores
		
		
		//Mueve bala o mata la bala
		if(vidaBala==1 && ronda!=0){	
			sprite03.cy=my;
			sprite03.cx=mx;
		}
		else 
		{
			vidaBala=0;
			ronda=0;		//ronda sin bala
			direccion2=4; //direccion bala borrada
			sprite03.sp1=noCoin;
			sprite03.sp0=noCoin;
		}
		//Fin mueve balas
		//FIN DANIEL
		
		
		//IA  Te persigue si entras en su rango, si no se mueve de izquierda a derecha
	
		//DANIEL - copia este if al principio del movimiento del enemigo, si el bloqueo esta activo el enemigo no se mueve
		if(bloqueo!=1){//Bloqueo desactivado
			if(puntostotales>10 && powerUpEnMapa == 0){
							if(sprite02.cx < sprite00.cx){
								sprite02.cx++;
							} 
							if(sprite02.cy < sprite00.cy ){
								sprite02.cy++;
							}
							if(sprite02.cx > sprite00.cx ){
								sprite02.cx--;
							}
							if(sprite02.cy > sprite00.cy ){
								sprite02.cy--;
							}
					
			}else{
				if(((sprite00.cy - sprite02.cy < (50) && sprite00.cy >= sprite02.cy) || (sprite00.cy - sprite02.cy > (-50) && sprite00.cy <= sprite02.cy) ) && ((sprite00.cx - sprite02.cx > (-15) && sprite00.cx <= sprite02.cx) || (sprite00.cx - sprite02.cx < (15) && sprite00.cx >= sprite02.cx)))
				{
							if(sprite02.cx < sprite00.cx){
								sprite02.cx++;
							}else 
							if(sprite02.cy < sprite00.cy ){
								sprite02.cy++;
							}else
							if(sprite02.cx > sprite00.cx ){
								sprite02.cx--;
							}else
							if(sprite02.cy > sprite00.cy ){
								sprite02.cy--;
							}
				
				}else if(powerUpEnMapa == 1 )
				{
					if(sprite02.cx < powerup.cx){
								sprite02.cx++;
							}else 
							if(sprite02.cy < powerup.cy ){
								sprite02.cy+=2;
							}else
							if(sprite02.cx > powerup.cx ){
								sprite02.cx--;
							}else
							if(sprite02.cy > powerup.cy ){
								sprite02.cy-=2;
							}		
				}else{
						if (sprite02.cx >8 && sprite02.cy>=90 )   //1 = izquierda, 2 = derecha
						{
							sprite02.cx--;
						}else
						
						if (sprite02.cx <=8 && sprite02.cy>6 )
						{
							sprite02.cy-=2;
						}else
						
						if(sprite02.cx <50 && sprite02.cy>=6)
						{
							sprite02.cx++;
						}else if(sprite02.cx>=50 && sprite02.cy <90)
						{
							sprite02.cy+=2;
						}
					}
			}
		}
		
        
     


        cpc_ResetTouchedTiles();		//clear touched tile table

        //Sprite phase 1
        cpc_PutSpTileMap(p_sprites[0]);		//search the tiles where is and was the sprite
     
		cpc_PutSpTileMap(p_sprites[1]);
       	//if(contador%2==0){
		cpc_PutSpTileMap(p_sprites[2]);//}
		//bala
		
		cpc_PutSpTileMap(p_sprites[3]);
		
		cpc_PutSpTileMap(p_sprites[4]);
		
		cpc_PutSpTileMap(p_sprites[5]);
		
		//VICENTE
		cpc_PutSpTileMap(p_sprites[6]);
		
		cpc_PutSpTileMap(p_sprites[7]);
		//VICENTE


        cpc_UpdScr(); 					//Update the screen to new situatio (show the touched tiles)

        //Sprite phase 2
        cpc_PutMaskSpTileMap2b(p_sprites[0]);	//Requires to move sprite with cpc_SpUpdX or cpc_SpUpdY
     
		cpc_PutMaskSpTileMap2b(p_sprites[1]);
       
		cpc_PutMaskSpTileMap2b(p_sprites[2]);
		//bala
		
		cpc_PutMaskSpTileMap2b(p_sprites[3]);
		
		cpc_PutMaskSpTileMap2b(p_sprites[4]);
		
		cpc_PutMaskSpTileMap2b(p_sprites[5]);
		
		//VICENTE
		cpc_PutMaskSpTileMap2b(p_sprites[6]);
		
		cpc_PutMaskSpTileMap2b(p_sprites[7]);
		//VICENTE
		

        cpc_ShowTileMap2();			//Show the touched tiles-> show the new sprite situatuion

		
		//esto comprueba si hay colisiones entre dos sprites
       if (cpc_CollSp(p_sprites[0],p_sprites[2])){
			a = collide();  //test if there is collision between sprite00 and sprite01
			if(a == 0){					
				initGame(); 	// Reinitialize game
			}
			else{
				c_exit();
			}
		}

		//DANIEL -- copia y pega metodo para otro malo, si usas el mismo se solaparan
		//Funcion de impacto - Bloquea enemigo-bala
		if(bloqueo==0 && vidaBala==1){
			if(cpc_CollSp(p_sprites[3],p_sprites[2])){ //COLISION --> Bala-alien
				bloqueo=1;
				contador++;
			}
		}
		//Tiempo de bloqueo del enemigo
		if(bloqueo==1 && contador < 20)
		{	contador++; 
				if(contador==20){//tiempo de bloqueo cumplido
					contador =0;
					bloqueo = 0;
				}
		}
		//FIN DANIEL
		
		//zona de generar randoms
		rand++;
		if(rand>99)
		{
			rand = 0;
		}
		
		rand2++;
		if(rand2>50)
		{
			rand2 = 5;
		}
		
		rand3++;
		if(rand3>120)
		{
			rand3=60;
		}
		
		//coge moneda
		 if (cpc_CollSp(p_sprites[0],p_sprites[1]) && cont ==0){
			cifra0++;
			cpc_WyzStartEffect(2,0); 
			actuaPuntos();
			pintapuntos();
			cont =1;
			sprite01.sp0 =noCoin ;
			sprite01.sp1 =noCoin ;
			
		 }
		 
		 	//situa moneda
			if(cont>=1)
			{
				cont++;
				if(cont>=60)
				{
					sprite01.cx = rand2;
					sprite01.cy = rand;
					sprite01.sp0 =sp_2 ;
					sprite01.sp1 =sp_2 ;
					cont = 0;
				}
				
			}
		 
		
		 
		 //coger powerup
		 if (cpc_CollSp(p_sprites[0],p_sprites[5]) && powerUpEnMapa ==1){
			cifra0++;
			actuaPuntos();
			pintapuntos();
			tPowerUp = 1;
			powerUpOn = 1;
			velPowerUp=1;
			powerup.sp0 =noCoin ;
			powerup.sp1 =noCoin ;
			powerUpEnMapa = 0;
			
		 }
		 
		 //malo coge powerup
		 if(powerUpEnMapa ==1){
		  if (cpc_CollSp(p_sprites[5],p_sprites[2])){
			tPowerUp = 1;
			powerUpOn = 1;
			powerup.sp0 =noCoin ;
			powerup.sp1 =noCoin ;
			powerup.cx=0;
			powerup.cy=0;
			powerUpEnMapa = 0;
			
			}
		 }
		 
		 //coloca el powerup
		 if(powerUpEnMapa == 0)
		 {
			tPowerUpSpawn++;
			if(tPowerUpSpawn > tRespawn)
			{
				powerup.cx = rand2;
				powerup.cy = rand;
				powerup.sp0 =sp_6 ;
				powerup.sp1 =sp_6 ;
				powerUpEnMapa = 1;
				tPowerUpSpawn=0;
				tRespawn = rand3;
			}
		 }
		 
		 
			//quita el powerup
			if(powerUpOn==1)
			{
				tPowerUp++;
				if(tPowerUp>=15)
				{
					velPowerUp=0;
					tPowerUp=0;
					powerUpOn=0;
				}
			}
		 
		  //coge powerdown
		 if (cpc_CollSp(p_sprites[0],p_sprites[4]) && powerdownEnMapa == 1){
			bloqueoJugador=1;
			tbloqueoJ =1;
			powerdownEnMapa=0;
			powerdown.sp0 =noCoin ;
			powerdown.sp1 =noCoin ;
		 }
		 
		 //coloca el powerdown
		  if(powerdownEnMapa == 0)
		 {
			tPowerDownSpawn++;
			if(tPowerDownSpawn > 45)
			{
				powerdown.cx = rand2;
				powerdown.cy = rand;
				powerdown.sp0 =sp_5 ;
				powerdown.sp1 =sp_5 ;
				powerdownEnMapa = 1;
				tPowerDownSpawn=0;
			}
		 }
		 
		 //quita el bloqueo
			if(tbloqueoJ>=1)
			{
				tbloqueoJ++;
				if(tbloqueoJ>=15)
				{
					bloqueoJugador =0;
					tbloqueoJ=0;
				}
			}
			
		//VICENTE
		if(sprite00.cx - enemy2.cx <= 20){	//ENEMIGO IZQUIERDA
			if(sprite00.cy>enemy2.cy){
				enemy2.cy++;
			}
			else if(sprite00.cy<enemy2.cy){
				enemy2.cy--;
			}
		}
		
		if(enemy3.cx - sprite00.cx <= 20){	//ENEMIGO DERECHA
			if(sprite00.cy>enemy3.cy){
				enemy3.cy++;
			}
			else if(sprite00.cy<enemy3.cy){
				enemy3.cy--;
			}
		}
		
		if(enemy3.cx - powerdown.cx < 15){
			if(enemy3.cy - powerdown.cy < 4 && enemy3.cy - powerdown.cy > (-4) ){
				powerdown.cx-=2;
			}
		}
		if(powerdown.cx - enemy2.cx < 15){
			if(enemy3.cy - powerdown.cy < 4 && enemy3.cy - powerdown.cy > (-4) ){
				powerdown.cx+=2;
			}
		}
		
		
		if (cpc_CollSp(p_sprites[0],p_sprites[6])){
			a = collide();  //test if there is collision between sprite00 and sprite01
			if(a == 0){					
				initGame(); 	// Reinitialize game
			}
			else{
				c_exit();
			}
		}
		
		if (cpc_CollSp(p_sprites[0],p_sprites[7])){
			a = collide();  //test if there is collision between sprite00 and sprite01
			if(a == 0){					
				initGame(); 	// Reinitialize game
			}
			else{
				c_exit();
			}
		}
		//VICENTE
		
		//DANIEL -- añade otro bloqueo para otro malo y arreando
		//Margenes de la bala o impacto
		if(sprite03.cx<5 || sprite03.cx>50 || sprite03.cy<5 || sprite03.cy>100 || bloqueo==1){ //bloqueo se lanza cuando hay colision enemigo-bala
			ronda=0;	
			vidaBala=0;			
		}
		//FIN DANIEL
		
		
		//Contador tiempo
		time++;
		if(time==60) time = 0;
		
		
    }
}




